//+------------------------------------------------------------------+
//|                                                    MaChannel.mq4 |
//|                                                      Coders Guru |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+

#property copyright "Coders Guru"
#property link      "http://www.forex-tsd.com"

//---- Includes
#include <stdlib.mqh>

//---- Trades limits
extern double    TakeProfit = 120;
extern double    TrailingStop = 30; 
extern double    StopLoss = 60;
extern double    Lots = 0.01; 
extern double    devU = 0;
extern double    devL = 0;
extern int       Slippage = 5;

//--- External options
extern int       CurrentBar = 1;
extern double    Expiration = 7200;
extern int       HedgeLevel = 6;
extern int       Size = 4;
extern int       Step = 1;
extern bool      UseClose = true;


//--- Indicators settings
extern int       USMA = 8;
extern int       LSMA = 8; 
extern int       mMA1 = 10; //Main trend ma filter signal sma
extern int       mMA2 = 20; //Main trend ma filter slow ema
extern bool      Usemtrend = true;
extern bool      Usevols = true;

//--- Global variables
int      MagicNumber = 101050;
string   ExpertComment = "MaChannel";

bool     LimitPairs = true;
bool     LimitFrame = true;
int      TimeFrame = 60; //Works with 1 hour timeframe only!
string   LP[] = {"EURUSD","EURGBP","USDCHF"}; // add/remove the paris you want to limit.
bool     Optimize = false;
int      NumberOfTries = 5;
bool      OStop,OTake,OTrail;
//+------------------------------------------------------------------
int init()
{
   if (Usevols) {
      OStop = StopLoss;
      OTake = TakeProfit;
      OTrail = TrailingStop;
   }

   return(0);
}

int deinit() 
{
   return(0);
}
//+------------------------------------------------------------------

bool isNewSymbol(string current_symbol)
  {
   //loop through all the opened order and compare the symbols
   int total  = OrdersTotal();
   for(int cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      string selected_symbol = OrderSymbol();
      if (current_symbol == selected_symbol && OrderMagicNumber()==MagicNumber)
      return (False);
    }
    return (True);
}

//+------------------------------------------------------------------+
int start()
  {
   int cnt, ticket, total,n;
   double trend1,trend2,trend3,trend4,mtrend1,mtrend2 ;
   
   if(Bars<100) {Print("bars less than 100"); return(0);}
   
   
   if(LimitFrame)
   { 
      if(Period()!=TimeFrame) {Print("This EA is not working with this TimeFrame!"); return(0);}
   }
   if(LimitPairs)
   { 
      if(AllowedPair(Symbol()) == false) {Print("This EA is not working with this Currency!"); return(0);}
   }   
   
   //trend1 = iMA(NULL,0,LSMA,0,MODE_SMA,PRICE_LOW,CurrentBar);
   //trend2 = iMA(NULL,0,USMA,0,MODE_SMA,PRICE_LOW,CurrentBar);
   //trend3 = iMA(NULL,0,LSMA,0,MODE_SMA,PRICE_HIGH,CurrentBar);
   //trend4 = iMA(NULL,0,USMA,0,MODE_SMA,PRICE_HIGH,CurrentBar);
   
   trend1 = iEnvelopes(NULL,0,LSMA,MODE_SMA,0,PRICE_LOW,devL,MODE_LOWER,CurrentBar);
   trend2 = iEnvelopes(NULL,0,LSMA,MODE_SMA,0,PRICE_LOW,devU,MODE_LOWER,CurrentBar+1);
   trend3 = iEnvelopes(NULL,0,USMA,MODE_SMA,0,PRICE_HIGH,devL,MODE_UPPER,CurrentBar);
   trend4 = iEnvelopes(NULL,0,USMA,MODE_SMA,0,PRICE_HIGH,devU,MODE_UPPER,CurrentBar+1);
   
   
   if (Usemtrend) mtrend1 = iMA(NULL, 240, mMA1,0, MODE_SMA,PRICE_CLOSE,0);
   if (Usemtrend) mtrend2 = iMA(NULL, 240, mMA2,0, MODE_EMA,PRICE_CLOSE,0);
   
   //Calc StopLoss if Vols is true
   if (Usevols) {
      StopLoss = iATR(NULL,1440,14,CurrentBar)/ 100 * OStop / Point;
      TakeProfit = iATR(NULL,1440,14,CurrentBar)/ 100 * OTake / Point;
      TrailingStop = iATR(NULL,1440,14,CurrentBar)/ 100 * OTrail / Point;
   }
   
   //--- Trading conditions
   bool BuyCondition = false , SellCondition = false , CloseBuyCondition = false , CloseSellCondition = false ; 
   
   if (!Usemtrend) {mtrend1 = 1; mtrend2 = 0;}
   
   if (High[CurrentBar] < trend1 && High[CurrentBar+1] < trend2 && mtrend1 > mtrend2)
       BuyCondition = true;
   
   if (!Usemtrend) {mtrend1 = 0; mtrend2 = 1;}    
   
   if (Low[CurrentBar] > trend3 && Low[CurrentBar+1] > trend4 && mtrend1 < mtrend2)
      SellCondition = true;
  
   if (SellCondition)
      CloseBuyCondition = true;
      
   if (BuyCondition)
      CloseSellCondition = true;
      
   
   total  = OrdersTotal();
   
   if(total < 1 || isNewSymbol(Symbol())) 
     {
       if(BuyCondition) //<-- BUY condition
         {
           ticket = OpenOrder(OP_BUY); //<-- Open BUY order
           CheckError(ticket,"BUY");
            
            for(n=0 ; n< Size ; n++)
            {            
               ticket = OpenPendingOrder(OP_BUYSTOP,Lots,HedgeLevel+(n*Step+1),Slippage,StopLoss,TakeProfit,ExpertComment,MagicNumber,CurTime() + Expiration);
            }
            return(0);
         }
         if(SellCondition) //<-- SELL condition
         {
            ticket = OpenOrder(OP_SELL); //<-- Open SELL order
            
            for(n=0 ; n < Size ; n++)
            {
               ticket = OpenPendingOrder(OP_SELLSTOP,Lots,HedgeLevel+(n*Step+1),Slippage,StopLoss,TakeProfit,ExpertComment,MagicNumber,CurTime() + Expiration);
            }
            return(0);
         }
         return(0);
     }
     
      for(cnt=0;cnt<total;cnt++) 
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
         {
            if(OrderType()==OP_BUY)   //<-- Long position is opened
            {
               if(UseClose)
               {
                  if(CloseBuyCondition) //<-- Close the order and exit! 
                  {
                     CloseOrder(OrderType()); 
                  } 
               }
               
               TrailOrder(OrderType()); //<-- Trailling the order
            }
            if(OrderType()==OP_SELL) //<-- Go to short position
            {
               if(UseClose)
               {
                  if(CloseSellCondition) //<-- Close the order and exit! 
                  {
                     CloseOrder(OP_SELL); 
                  } 
               }
               
               TrailOrder(OrderType()); //<-- Trailling the order
            }
         }
      }

   return(0);
  }
//+------------------------------------------------------------------+

int OpenOrder(int type)
{
   int ticket=0;
   int err=0;
   int c = 0;
   
   if(type==OP_BUY)
   {
      for(c = 0 ; c < NumberOfTries ; c++)
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,ExpertComment,MagicNumber,0,Green);
         err=GetLastError();
         if(err==0)
         { 
            break;
         }
         else
         {
            if(err==4 || err==137 ||err==146 || err==136) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               break;
            }  
         }
      }   
   }
   if(type==OP_SELL)
   {   
      for(c = 0 ; c < NumberOfTries ; c++)
      {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,ExpertComment,MagicNumber,0,Red);
         err=GetLastError();
         if(err==0)
         { 
            break;
         }
         else
         {
            if(err==4 || err==137 ||err==146 || err==136) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               break;
            }  
         }
      }   
   }  
   return(ticket);
}

int OpenPendingOrder(int pType=OP_BUYLIMIT,double pLots=1,double pLevel=5,int sp=0, double sl=0,double tp=0,string pComment="",int pMagic=123,datetime pExpiration=0,color pColor=Yellow)
{
  int ticket=0;
  int err=0;
  int c = 0;
  
  switch (pType)
  {
      case OP_BUYLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYLIMIT,pLots,Ask-pLevel*Point,sp,(Ask-pLevel*Point)-sl*Point,(Ask-pLevel*Point)+tp*Point,pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         }   
         break;
      case OP_BUYSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYSTOP,pLots,Ask+pLevel*Point,sp,(Ask+pLevel*Point)-sl*Point,(Ask+pLevel*Point)+tp*Point,pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELLLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLLIMIT,pLots,Bid+pLevel*Point,sp,(Bid+pLevel*Point)+sl*Point,(Bid+pLevel*Point)-tp*Point,pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELLSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLSTOP,pLots,Bid-pLevel*Point,sp,(Bid-pLevel*Point)+sl*Point,(Bid-pLevel*Point)-tp*Point,pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
  } 
  
  return(ticket);
}

bool CloseOrder(int type)
{
   if(OrderMagicNumber() == MagicNumber)
   {
      if(type==OP_BUY)
         return (OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet));
      if(type==OP_SELL)   
         return (OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet));
   }
}
void TrailOrder(int type)
{
   if(TrailingStop>0)
   {
      if(OrderMagicNumber() == MagicNumber)
      {
         if(type==OP_BUY)
         {
            if(Bid-OrderOpenPrice()>Point*TrailingStop)
            {
               if(OrderStopLoss()<Bid-Point*TrailingStop)
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
               }
            }
         }
         if(type==OP_SELL)
         {
            if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
            {
               if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
               }
            }
         }
      }
   }
}

void CheckError(int ticket, string Type)
{
    if(ticket>0)
    {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print(Type + " order opened : ",OrderOpenPrice());
    }   
    else Print("Error opening " + Type + " order : ", ErrorDescription(GetLastError()));
}

bool AllowedPair(string pair)
{
   bool result=false;
   for (int n = 0 ; n < ArraySize(LP); n++)
   {
      if(Symbol() == LP[n])
      {
         result = true;
      }
   }
   return (result);
}


